import .connectives
import .leibniz
import .logic
axiom nat.nat : Type.
constant nat.S : (nat.nat) -> nat.nat.
constant nat.match_nat_type : forall (return : Type) , (return) -> ((nat.nat) -> return) -> (nat.nat) -> return.
axiom nat.axiom_match_nat_type_S : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , forall (n:nat.nat) , (((connectives.equal) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n)).
theorem nat.eq_match_nat_type_S : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n)) := fun (return_type : Type) , fun (case_O : return_type) , fun (case_S : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@connectives.equal_leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n))) (((((@nat.axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
constant nat.filter_nat_type : forall (return : Type) , ((nat.nat) -> return) -> (nat.nat) -> return.
axiom nat.axiom_filter_nat_type_S : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , forall (n:nat.nat) , (((connectives.equal) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n)))) ((return) (((nat.S) ) (n))).
theorem nat.eq_filter_nat_type_S : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n)))) ((return) (((nat.S) ) (n))) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@connectives.equal_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n)))) ((return) (((nat.S) ) (n)))) ((((@nat.axiom_filter_nat_type_S) (return_type)) (return)) (n)).
constant nat.minus : (nat.nat) -> (nat.nat) -> nat.nat.
constant nat.minus_body : (nat.nat) -> (nat.nat) -> nat.nat.
axiom nat.axiom_minus : forall (n:nat.nat) , (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.minus) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.minus_body) )) (n)).
theorem nat.eq_minus : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.minus) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.minus_body) )) (n)) := fun (n : nat.nat) , ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.minus) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.minus_body) )) (n))) ((@nat.axiom_minus) (n)).
axiom nat.axiom_minus_body_S : forall (n:nat.nat) , (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.minus_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , ((((nat.match_nat_type) (nat.nat)) (((nat.S) ) (n))) (fun (q : nat.nat) , (((nat.minus) ) (n)) (q))) (m)).
theorem nat.eq_minus_body_S : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.minus_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , ((((nat.match_nat_type) (nat.nat)) (((nat.S) ) (n))) (fun (q : nat.nat) , (((nat.minus) ) (n)) (q))) (m)) := fun (n : nat.nat) , ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.minus_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , ((((nat.match_nat_type) (nat.nat)) (((nat.S) ) (n))) (fun (q : nat.nat) , (((nat.minus) ) (n)) (q))) (m))) ((@nat.axiom_minus_body_S) (n)).
theorem nat.minus_S_S : forall (n:nat.nat) , forall (m:nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.minus) ) (((nat.S) ) (n))) (((nat.S) ) (m)))) ((((nat.minus) ) (n)) (m)) := fun (n : nat.nat) , fun (m : nat.nat) , ((((((@nat.eq_match_nat_type_S) (nat.nat)) (((nat.S) ) (n))) (fun (q : nat.nat) , (((nat.minus) ) (n)) (q))) (m)) (fun (y : nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.minus) ) (((nat.S) ) (n))) (((nat.S) ) (m)))) (y))) ((((@nat.eq_minus_body_S) (n)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.minus) ) (((nat.S) ) (n))) (((nat.S) ) (m)))) ((y) (((nat.S) ) (m))))) ((((((@nat.eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.minus_body) )) (n)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.minus) ) (((nat.S) ) (n))) (((nat.S) ) (m)))) ((y) (((nat.S) ) (m))))) ((((@nat.eq_minus) (((nat.S) ) (n))) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.minus) ) (((nat.S) ) (n))) (((nat.S) ) (m)))) ((y) (((nat.S) ) (m))))) (((@logic.refl_) (nat.nat)) ((((nat.minus) ) (((nat.S) ) (n))) (((nat.S) ) (m))))))).
